/* Any copyright is dedicated to the Public Domain.
   http://creativecommons.org/publicdomain/zero/1.0/ */
/* Bug 650760 */

function test() {
  waitForExplicitFinish();

  gBrowser.selectedTab = BrowserTestUtils.addTab(gBrowser);
  BrowserTestUtils.loadURI(
    gBrowser,
    "data:text/html,Test keybindings for opening Scratchpad MDN Documentation, bug 650760"
  );
  BrowserTestUtils.browserLoaded(gBrowser.selectedBrowser).then(function() {
    openScratchpad(runTest);
  });
}

function runTest() {
  const sp = gScratchpadWindow.Scratchpad;
  ok(sp, "Scratchpad object exists in new window");
  ok(sp.editor.hasFocus(), "the editor has focus");

  const keyid = gScratchpadWindow.document.getElementById("key_openHelp");
  const modifiers = keyid.getAttribute("modifiers");

  let key = null;
  if (keyid.getAttribute("keycode")) {
    key = keyid.getAttribute("keycode");
  } else if (keyid.getAttribute("key")) {
    key = keyid.getAttribute("key");
  }

  isnot(key, null, "Successfully retrieved keycode/key");

  var aEvent = {
    shiftKey: modifiers.match("shift"),
    ctrlKey: modifiers.match("ctrl"),
    altKey: modifiers.match("alt"),
    metaKey: modifiers.match("meta"),
    accelKey: modifiers.match("accel"),
  };

  info('check that the MDN page is opened on "F1"');
  let linkClicked = false;
  sp.openDocumentationPage = function(event) {
    linkClicked = true;
  };

  EventUtils.synthesizeKey(key, aEvent, gScratchpadWindow);

  is(linkClicked, true, "MDN page will open");
  finishTest();
}

function finishTest() {
  gScratchpadWindow.close();
  finish();
}
